using UnityEngine;
using UnityEngine.Events;
using System;
using System.Collections.Generic;
using MeshVR;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;
using Battlehub.RTSaveLoad;
using System.Linq;
using UnityEngine.UI;
using System.Text;
using MVR.FileManagementSecure;

namespace Ruvik
{
    class PH : MVRScript
    {
        string ASSETBUNDLEPATH;
        string keyString = string.Empty;
        public static JSONStorableFloat sensetivity, rotationSpeed,UIScale,UIOffsetX,UIOffsetY,RotationIncrements;
        public static JSONStorableBool adjustPosition, alignUpDown,changeFaicalPose,keepUIOpen;
        public JSONStorableStringChooser savemodes;
        readonly int SAVE_MODE_KEEP = 0;
        readonly int SAVE_MODE_RETRIEVE = 1;
        readonly int SAVE_MODE_CLEAR = 2;
        public static int SAVE_MODE = 1;
        GameObject identity;
        public static JSONStorableBool actBool = new JSONStorableBool("motion activation Key", false);
        public static JSONStorableBool switchMotionBool = new JSONStorableBool("motion switching Key(position/rotation)", false);
        public static JSONStorableBool switchAxisBool = new JSONStorableBool("axis switching Key(XY/Z)", false);
	    public static JSONStorableBool useOldPresets;

        public void OnBindingsListRequested(List<object> bindings)
        {
            bindings.Add(new JSONStorableAction("activate/deactive UI", () => PHUI.menuUIActive = !PHUI.menuUIActive));
            bindings.Add(new JSONStorableAction("clear selected bones", () => PHUI.ClearActiveNodes()));
            bindings.Add(new JSONStorableAction("ik link", () => PHUtils.IKLink()));
            bindings.Add(new JSONStorableAction("reset linking state", () => PHUtils.ResetLink_method()));
            bindings.Add(new JSONStorableAction("undo", () => PHUndo.RestoreState()));
            bindings.Add(new JSONStorableAction("load Pose", () => PHUtils.LoadPose(true)));
            bindings.Add(new JSONStorableAction("save Pose", () => { PHUI.SavePose(); }));
            bindings.Add(new JSONStorableAction("switch posing mode", () => { PHUI.ToggleBodyPosing();}));
            bindings.Add(actBool);
            bindings.Add(switchMotionBool);
            bindings.Add(switchAxisBool);
        }
        public static string GetPluginPath(MVRScript self)
        {
            string id = self.name.Substring(0, self.name.IndexOf('_'));
            string filename = self.manager.GetJSON()["plugins"][id].Value;
            return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
        }
        void Update()
        {
            ProccesKeyBindings();
            PHUtils.UpdateStates();
            if (!keepUIOpen.valNoCallback)
            {
                if (PHUI.menuUIActive)
                    PHUI.PHMenuSetActive(SuperController.singleton.MainHUDVisible);
                else
                    PHUI.PHMenuSetActive(false);
            }
            else
                PHUI.PHMenuSetActive(PHUI.menuUIActive);
        }
        public override void Init()
        {
            List<string> modes = new List<string>()
            {
                "Keep","Retrieve","Clear"
            };
            savemodes = new JSONStorableStringChooser("switch selection mode", modes, modes[1], "switch selection");
            sensetivity = new JSONStorableFloat("Sensitivity", 1.0f, 0.1f, 4.0f);
            rotationSpeed = new JSONStorableFloat("Rotation Speed", 2.5f, 0.1f, 10.0f);
            UIScale = new JSONStorableFloat("UI Scale", 1.0f, 0.5f, 2.0f);
            RotationIncrements = new JSONStorableFloat("Rotation Increments", 15.0f, 1.0f, 90.0f);
            UIOffsetX = new JSONStorableFloat("UI Offset X", 10.0f, 0.0f, 50.0f);
            UIOffsetY = new JSONStorableFloat("UI Offset Y", 10.0f, 0.0f, 50.0f);

            identity = new GameObject();
            identity.transform.position = Vector3.zero;
            identity.transform.rotation = Quaternion.identity;
            identity.transform.localScale = Vector3.one;
            PHUtils.motionTransform = new Transform[3] { null, identity.transform, SuperController.singleton.lookCamera.transform };

            RegisterAction(new JSONStorableAction("activate/deactive UI", () => PHUI.menuUIActive = !PHUI.menuUIActive));
            RegisterAction(new JSONStorableAction("clear selected bones", () => PHUI.ClearActiveNodes()));
            RegisterAction(new JSONStorableAction("ik link", () => PHUtils.IKLink()));
            RegisterAction(new JSONStorableAction("reset linking state", () => PHUtils.ResetLink_method()));
            RegisterAction(new JSONStorableAction("undo", () => PHUndo.RestoreState()));

            var bb1 = CreatePopup(savemodes, true); bb1.popup.onValueChangeUnityEvent.AddListener(delegate (string a)
            {
                switch (a.ToLower())
                {
                    case "clear":
                        SAVE_MODE = SAVE_MODE_CLEAR;
                        break;
                    case "retrieve":
                        SAVE_MODE = SAVE_MODE_RETRIEVE;
                        break;
                    case "keep":
                        SAVE_MODE = SAVE_MODE_KEEP;
                        break;
                }
            });
            var btn = CreateButton("Show UI", false); btn.height = bb1.height; btn.button.onClick.AddListener(delegate () { PHUI.menuUIActive = true; });

            CreateSlider(sensetivity, false);
            CreateSlider(rotationSpeed, true);

            CreateSpacer(true).height = 20;
            CreateSpacer(false).height = 20;

            PHUtils.xPosMultiplier = CreateInverseButton("invert X Pos",false, delegate (bool a) { PHUtils.xPosMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.yPosMultiplier = CreateInverseButton("invert Y Pos",false, delegate (bool a) { PHUtils.yPosMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.zPosMultiplier = CreateInverseButton("invert Z Pos",false, delegate (bool a) { PHUtils.zPosMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.xRotMultiplier = CreateInverseButton("invert X Rot",true, delegate (bool a) { PHUtils.xRotMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.yRotMultiplier = CreateInverseButton("invert Y Rot",true, delegate (bool a) { PHUtils.yRotMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.zRotMultiplier = CreateInverseButton("invert Z Rot",true, delegate (bool a) { PHUtils.zRotMultiplier = a ? -1.0f : 1.0f; });

            CreateSpacer(true).height = 20;
            CreateSpacer(false).height = 20;

	        useOldPresets = new JSONStorableBool("use old presets", false);

            CreateSpacer(true).height = 20;
            CreateSpacer(false).height = 20;


            CreateSlider(UIOffsetX, true).slider.onValueChanged.AddListener((float val) => { if (PHUI.rootRect == null) return; PHUI.rootRect.anchoredPosition = new Vector3(-val, UIOffsetY.valNoCallback, 0); });
            CreateSlider(UIOffsetY, true).slider.onValueChanged.AddListener((float val) => { if (PHUI.rootRect == null) return; PHUI.rootRect.anchoredPosition = new Vector3(-UIOffsetX.valNoCallback, val, 0); });
            CreateSlider(UIScale, true).slider.onValueChanged.AddListener((float val) => { if (PHUI.rootRect == null) return; PHUI.rootRect.localScale = Vector3.one * val;});
            changeFaicalPose = new JSONStorableBool("change facial expression", true);
            CreateToggle(changeFaicalPose, false);

            keepUIOpen = new JSONStorableBool("keep UI open", false);
            CreateToggle(keepUIOpen, false);

            CreateToggle(useOldPresets, false);

            CreateSlider(RotationIncrements, false).slider.onValueChanged.AddListener((float val) => { PHMove.rotatoinIncrements = val;});

            var saveBtn = CreateButton("Save settings");
            saveBtn.height = 125;
            saveBtn.button.onClick.AddListener(SaveSettings);
            CreateButton("Force Reload Fingers", true).button.onClick.AddListener(() => { PHHands.usedAtoms.Clear(); });

            SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);
            ASSETBUNDLEPATH = GetPluginPath(this) + "/assets/ph";
            Request request = new Request { path = ASSETBUNDLEPATH, callback = OnAssetBundleLoaded };
            AssetLoader.QueueLoadAssetBundleFromFile(request);
            PHLinker.InitGraph();
            LoadSettings();
        }
        void SaveSettings()
        {
            StringBuilder settings = new StringBuilder();
            settings.AppendLine("#PH config");
            settings.AppendLine("Sensitivity:" + sensetivity.valNoCallback);
            settings.AppendLine("Rotation Speed:" + rotationSpeed.valNoCallback);
            settings.AppendLine("Save Mode:" + SAVE_MODE);
            settings.AppendLine("IPX:" + PHUtils.xPosMultiplier);
            settings.AppendLine("IPY:" + PHUtils.yPosMultiplier);
            settings.AppendLine("IPZ:" + PHUtils.zPosMultiplier);
            settings.AppendLine("IRX:" + PHUtils.xRotMultiplier);
            settings.AppendLine("IRY:" + PHUtils.yRotMultiplier);
            settings.AppendLine("IRZ:" + PHUtils.zRotMultiplier);
            settings.AppendLine("Change Faical:" + changeFaicalPose.valNoCallback);
            settings.AppendLine("Keep Open:" + keepUIOpen.valNoCallback);
            settings.AppendLine("Old Presets:" + useOldPresets.valNoCallback);
            settings.AppendLine("UIOffsetX:" + UIOffsetX.valNoCallback);
            settings.AppendLine("UIOffsetY:" + UIOffsetY.valNoCallback);
            settings.AppendLine("UIScale:" + UIScale.valNoCallback);
            FileManagerSecure.CreateDirectory("Saves\\PluginData\\PH");
            FileManagerSecure.WriteAllText("Saves\\PluginData\\PH\\PHCONFIG",settings.ToString());
        }
        void LoadSettings()
        {
            if (!FileManagerSecure.GetDirectories("Saves\\PluginData").Any(folder => folder == "Saves\\PluginData\\PH"))
                return;
            string settings = FileManagerSecure.ReadAllText("Saves\\PluginData\\PH\\PHCONFIG");
            if (string.IsNullOrEmpty(settings))
                return;
            foreach (var setting in settings.Split(new string[] { "\n", "\r\n" },StringSplitOptions.None))
            {
                if (string.IsNullOrEmpty(setting))
                    continue;
                if (setting.StartsWith("#"))
                    continue;
                string name = setting.Split(':')[0];
                string value = setting.Split(':')[1];
                switch(name)
                {
                    case "Sensitivity":
                        sensetivity.val= float.Parse(value);
                        break;
                    case "Rotation Speed":
                        rotationSpeed.val= float.Parse(value);
                        break;
                    case "Save Mode":
                        SAVE_MODE = int.Parse(value);
                        savemodes.SetVal(savemodes.choices[SAVE_MODE]);
                        break;
                    case "IPX":
                        PHUtils.xPosMultiplier = float.Parse(value);
                        GetBoolJSONParam("invert X Pos").val = float.Parse(value) == -1.0f;
                        break;
                    case "IPY":
                        PHUtils.yPosMultiplier = float.Parse(value);
                        GetBoolJSONParam("invert Y Pos").val = float.Parse(value) == -1.0f;
                        break;
                    case "IPZ":
                        PHUtils.zPosMultiplier = float.Parse(value);
                        GetBoolJSONParam("invert Z Pos").val = float.Parse(value) == -1.0f;
                        break;
                    case "IRX":
                        PHUtils.xRotMultiplier = float.Parse(value);
                        GetBoolJSONParam("invert X Rot").val = float.Parse(value) == -1.0f;
                        break;
                    case "IRY":
                        PHUtils.yRotMultiplier = float.Parse(value);
                        GetBoolJSONParam("invert Y Rot").val = float.Parse(value) == -1.0f;
                        break;
                    case "IRZ":
                        PHUtils.zRotMultiplier = float.Parse(value);
                        GetBoolJSONParam("invert Z Rot").val = float.Parse(value) == -1.0f;
                        break;
                    case "Change Faical":
                        changeFaicalPose.val= bool.Parse(value);
                        break;
                    case "Keep Open":
                        keepUIOpen.val= bool.Parse(value);
                        break;
                    case "Old Presets":
                        useOldPresets.val= bool.Parse(value);
                        break;
                    case "UIOffsetX":
                        UIOffsetX.val= float.Parse(value);
                        break;
                    case "UIOffsetY":
                        UIOffsetY.val= float.Parse(value);
                        break;
                    case "UIScale":
                        UIScale.val= float.Parse(value);
                        break;
                }
            }
        }
        public float CreateInverseButton(string name, bool right, UnityAction<bool> toggleAction)
        {
            JSONStorableBool storableBool = new JSONStorableBool(name, false,(b)=> { toggleAction(b); });
            RegisterBool(storableBool);
            CreateToggle(storableBool, right);
            return storableBool.val ? 1.0f : -1.0f;
        }

        bool beingHeld = false;
        void ProccesKeyBindings()
        {
            if (actBool.valNoCallback && !beingHeld)
            {
                beingHeld = true;
                PHUtils.PreMoveControllers();
            }

            if (actBool.valNoCallback && beingHeld)
            {
                float x, y;
                Vector3 moveby;
                x = Input.GetAxis("Mouse X");
                y = Input.GetAxis("Mouse Y");
                moveby = switchAxisBool.valNoCallback ? new Vector3(0, 0, x + y) : new Vector3(x, y, 0);
                if (switchMotionBool.valNoCallback)
                    PHUtils.RotateActiveNodes(moveby);
                else
                    PHUtils.MoveActiveNodes(moveby);
            }
            if (!actBool.valNoCallback && beingHeld)
            {
                beingHeld = false;
                PHUtils.PostMoveControllers();
            }
            if(PHInput.GetModifier(PHInput.MODIFIER_CTRL))
                PHUI.alignmentText.text = PHUI.alingmentStrings[1];
            else if (PHInput.GetModifier(PHInput.MODIFIER_SHIFT))
                PHUI.alignmentText.text = PHUI.alingmentStrings[2];
            else if (PHInput.GetModifier(PHInput.MODIFIER_ALT))
                PHUI.alignmentText.text = PHUI.alingmentStrings[3];
            else
                PHUI.alignmentText.text = PHUI.alingmentStrings[PHUtils.motionTransformIndex];
        }
        public void OnDestroy()
        {

            AssetLoader.DoneWithAssetBundleFromFile(ASSETBUNDLEPATH);
            SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);
            PHUI.PHMenuDesroy();
            Destroy(identity);
        }
        public void OnDisable()
        {
            PHUI.PHMenuSetActive(false);
        }
        public void OnEnable()
        {
            PHUI.PHMenuSetActive(true);
        }
        private void OnAssetBundleLoaded(Request aRequest)
        {
            var PHUIAsset = aRequest.assetBundle.LoadAsset<GameObject>("Assets/ph/posinghelperui.prefab");
            var off_off = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/off_off.png");
            var off_on = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/off_on.png");
            var on_off = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/on_off.png");
            var on_on = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/on_on.png");
            var body = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/body.png");
            if (PHUIAsset != null)
            {
                PHUI.phGameObject = Instantiate(PHUIAsset);
                PHUI.stateTextures.Add("off_off", off_off);
                PHUI.stateTextures.Add("off_on", off_on);
                PHUI.stateTextures.Add("on_off", on_off);
                PHUI.stateTextures.Add("on_on", on_on);
                PHUI.stateTextures.Add("body", body);
                try
                {
                    PHUI.InitPHUI();
                }
                catch (Exception e)
                {
                    SuperController.LogError(e.Source+e.Message);
                }
            }
        }

    }
}
