using System;
using System.Runtime.CompilerServices;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

namespace Ruvik
{
    public class PHEyes
    {
        public static int state = 1;
        public static int[] states = { STATE_PLAYER, STATE_TARGET,STATE_NONE};
        public static string[] statesText = {"Player","Target","None"};
        public const int STATE_PLAYER = 0;
        public const int STATE_TARGET = 1;
        public const int STATE_NONE = 2;
        private static GameObject eyeUI;
        private static Image eyeSprite;
        private static Text eyeText;
        public static void Init()
        {
            eyeUI = GameObject.Find("PH_eye");
            eyeUI.AddComponent<EyeButton>();
            eyeSprite = eyeUI.GetComponent<Image>();
            eyeText = eyeUI.GetComponentInChildren<Text>();
        }
        public static void Update()
        {
            var eyeJSC = PHUtils.activeAtom.GetStorableByID("Eyes").GetStringChooserJSONParam("lookMode");
            for (int i = 0; i < statesText.Length; i++)
                if (statesText[i] == eyeJSC.valNoCallback)
                {
                    SetState(i);
                    return;
                }
            eyeText.text = eyeJSC.valNoCallback[0].ToString();
        }
        public static void SetState(int state)
        {
            PHEyes.state = state;
            eyeText.text = statesText[state][0].ToString();
            eyeSprite.color = eyeText.text == "N" ? Color.white : Color.green;
            PHUtils.activeAtom.GetStorableByID("Eyes").GetStringChooserJSONParam("lookMode").SetVal(statesText[state]);
        }
        public class EyeButton : MonoBehaviour, IPointerClickHandler
        {
            public void OnPointerClick(PointerEventData eventData)
            {
                if (eventData.button == PointerEventData.InputButton.Right)
                    if (PHInput.GetModifier(PHInput.MODIFIER_CTRL))
                        PHUtils.eyeTarget.SelectAlignToRigidbodyFromScene();
                    else
                        SuperController.singleton.SelectController(PHUtils.eyeTarget);

                if (eventData.button == PointerEventData.InputButton.Middle)
                    SetState(STATE_NONE);

                if (eventData.button == PointerEventData.InputButton.Left)
                {
                    state = (state + 1) % 2;
                    SetState(state);
                }
            }
        }
    }
}
