using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;
using System.Collections.Generic;
using Leap.Unity;
using System.Linq;
using Battlehub.RTSaveLoad;
using UnityEngine.Events;
using System;

namespace Ruvik
{
    public class PHUI
    {
        static public Dictionary<string, Sprite> stateTextures = new Dictionary<string, Sprite>(4);
        static public int MOUSE_LEFT = 0;
        static public int MOUSE_RIGHT = 1;
        static public int MOUSE_MIDDLE = 2;
        public static bool menuUIActive = false;
        public static GameObject phGameObject = null, phBodyPosingMenu = null, phHandPosingMenu = null, phHandPosingAdvanced = null, phHandPosingMinimal = null , phHelpMenu = null;
        public static Text activeAtomNameUI = null,alignmentText = null,handSideText,handModeText;
        public static string[] alingmentStrings = new string[4] { "local", "global", "cam", "node" };
        public static Image symmetryImage = null,collisionImage = null,freezeImage = null,onOffImage = null;
        public static int currentNameIndex = 0;
        static List<StateButton> stateButtons = new List<StateButton>();
        public static List<string> controllableAtoms = null;
        public static Dictionary<string,List<string>> RetrivedControllers= null;
        public static bool isBodyPosing = true,isRightSide = true;
        public static RectTransform rootRect = null;

        public static bool isSymmetryToggled = false;
        public static Dictionary<string, bool> symmetryDic = new Dictionary<string, bool>();
        static public void PHMenuDesroy()
        {
            if (phGameObject != null)
                GameObject.Destroy(phGameObject);
        }
        static public void PHMenuSetActive(bool state)
        {
            if (phGameObject != null)
                phGameObject.SetActive(state);
        }
        static public Node GetNodeByName(string name)
        {

            return GetNodeElemement(name).GetComponent<NodeSelector>().node;
        }
        public static void ActivateRightSide(bool activate)
        {
            if (!isBodyPosing)
                return;
            GetNodeElemement("rToe").GetComponent<NodeSelector>().SetInteractable(activate);
            GetNodeElemement("rFoot").GetComponent<NodeSelector>().SetInteractable(activate);
            GetNodeElemement("rThigh").GetComponent<NodeSelector>().SetInteractable(activate);
            GetNodeElemement("rKnee").GetComponent<NodeSelector>().SetInteractable(activate);
            GetNodeElemement("rElbow").GetComponent<NodeSelector>().SetInteractable(activate);
            GetNodeElemement("rArm").GetComponent<NodeSelector>().SetInteractable(activate);
            GetNodeElemement("rHand").GetComponent<NodeSelector>().SetInteractable(activate);
            GetNodeElemement("rShoulder").GetComponent<NodeSelector>().SetInteractable(activate);
            if(PHUtils.activeNodes.Count>0)
                PHUtils.activeNodes.RemoveAll(n => n.controller.name[0] == 'r');
        }
        public static void UpdateStates(Node n)
        {
            foreach(var sb in stateButtons)
            {
                bool pstate = n.controller.currentPositionState == sb.pState, rstate = n.controller.currentRotationState == sb.rState;
                sb.SetTexture(pstate, rstate);
            }
        }
        public static void SavePose()
        {
            SuperController.singleton.GetMediaPathDialog((string path) =>
            {
                PHUtils.SavePose(path);
            }, "vap", SuperController.singleton.savesDir + "../" + "Custom\\Atom\\Person\\Pose", false, false, true, "Preset_", true);
            uFileBrowser.FileBrowser browser = SuperController.singleton.mediaFileBrowserUI;
            browser.SetTextEntry(true);
            browser.fileEntryField.text = ((int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds).ToString();
            browser.ActivateFileNameField();
        }
        public static void SwitchSides()
        {
            isRightSide = !isRightSide;
            if (isRightSide)
                handSideText.text = "Right";
            else
                handSideText.text = "Left";
        }
        public static void InitPHUI()
        {
            RetrivedControllers = new Dictionary<string, List<string>>();
            rootRect = GameObject.Find("PH_root").GetComponent<RectTransform>();
            rootRect.localScale = Vector3.one * PH.UIScale.valNoCallback;
            rootRect.anchoredPosition = new Vector3(-PH.UIOffsetX.valNoCallback, PH.UIOffsetY.valNoCallback, 0);

            phBodyPosingMenu = GameObject.Find("PH_body");
            phHelpMenu = GameObject.Find("PH_help_menu");
            phHelpMenu.SetActive(false);
            phHandPosingMenu = GameObject.Find("PH_hand");
            phHandPosingAdvanced = GameObject.Find("PH_hand_advanced");
            phHandPosingMinimal = GameObject.Find("PH_hand_minimal");
            phHandPosingMinimal.SetActive(true);
            stateTextures["hand"] = GameObject.Find("PH_switch").transform.GetChild(0).GetComponent<Image>().sprite;

            InitGizmo();
            PHEyes.Init();
            GetNodeElemement("head").AddComponent<NodeSelector>();
            GetNodeElemement("abdomen").AddComponent<NodeSelector>();
            GetNodeElemement("neck").AddComponent<NodeSelector>();
            GetNodeElemement("hip").AddComponent<NodeSelector>();
            GetNodeElemement("pelvis").AddComponent<NodeSelector>();
            GetNodeElemement("chest").AddComponent<NodeSelector>();
            GetNodeElemement("penisMid").AddComponent<NodeSelector>();
            GetNodeElemement("penisBase").AddComponent<NodeSelector>();
            GetNodeElemement("penisTip").AddComponent<NodeSelector>();
            GetNodeElemement("abdomen2").AddComponent<NodeSelector>();
            GetNodeElemement("lToe").AddComponent<NodeSelector>();
            GetNodeElemement("rToe").AddComponent<NodeSelector>();
            GetNodeElemement("lFoot").AddComponent<NodeSelector>();
            GetNodeElemement("rFoot").AddComponent<NodeSelector>();
            GetNodeElemement("lKnee").AddComponent<NodeSelector>();
            GetNodeElemement("rKnee").AddComponent<NodeSelector>();
            GetNodeElemement("lThigh").AddComponent<NodeSelector>();
            GetNodeElemement("rThigh").AddComponent<NodeSelector>();
            GetNodeElemement("lShoulder").AddComponent<NodeSelector>();
            GetNodeElemement("rShoulder").AddComponent<NodeSelector>();
            GetNodeElemement("lArm").AddComponent<NodeSelector>();
            GetNodeElemement("rArm").AddComponent<NodeSelector>();
            GetNodeElemement("lElbow").AddComponent<NodeSelector>();
            GetNodeElemement("rElbow").AddComponent<NodeSelector>();
            GetNodeElemement("lHand").AddComponent<NodeSelector>();
            GetNodeElemement("rHand").AddComponent<NodeSelector>();
            GetNodeElemement("control").AddComponent<NodeSelector>();


            GameObject.Find("PH_hand_gizmo").AddComponent<HandGizmo>();
            PHHands.InitFingerSelectors();


            activeAtomNameUI = GameObject.Find("PH_node_control").GetComponentInChildren<Text>();
            alignmentText = GameObject.Find("PH_alignment").GetComponentInChildren<Text>();
            handSideText = GameObject.Find("PH_hand_side").GetComponentInChildren<Text>();
            handModeText = GameObject.Find("PH_hand_mode").GetComponentInChildren<Text>();
            handModeText.text = "min";
            handSideText.text = "Right";
            symmetryImage = GameObject.Find("PH_symmetry").GetComponent<Image>();
            freezeImage = GameObject.Find("PH_char_freeze").GetComponent<Image>();
            onOffImage = GameObject.Find("PH_char_state").GetComponent<Image>();
            collisionImage = GameObject.Find("PH_char_collision").GetComponent<Image>();
            GameObject.Find("PH_reset_pose").AddComponent<ResetButton>();
            GetButton("select_next").onClick.AddListener(delegate () { SelectNextAtom(); });
            GetButton("select_previous").onClick.AddListener(delegate () { SelectPreviousAtom(); });
            GetButton("symmetry").onClick.AddListener(delegate () { PHUtils.ToggleSymmetry(); });
            GetButton("undo").onClick.AddListener(delegate () { PHUndo.RestoreState(); });
            GetButton("char_state").onClick.AddListener(delegate () { PHUtils.ToggleState(); });
            GetButton("char_freeze").onClick.AddListener(delegate () { PHUtils.ToggleFreeze(); });
            GetButton("char_collision").onClick.AddListener(delegate () { PHUtils.ToggleCollision(); });
            GetButton("IK_link").onClick.AddListener(delegate () { PHUtils.IKLink(); });
            GetButton("clear_link").onClick.AddListener(delegate () { PHUtils.ClearLink(); });
            GetButton("load_pose").onClick.AddListener(delegate () { PHUtils.LoadPose(isBodyPosing); });
            GetButton("save_pose").onClick.AddListener(() => { if (isBodyPosing) { SavePose(); } else { PHHands.SavePose(); } });
            GetButton("hand_side").gameObject.AddComponent<PHHands.PHHandSideButton>();
            GetButton("help").onClick.AddListener(() => phHelpMenu.SetActive(!phHelpMenu.activeInHierarchy));
            GetButton("movement").onClick.AddListener(() => PHMove.ToggleUI());
            GetButton("hand_mode").onClick.AddListener(() =>
            {
                PHHands.SwitchMode();
            });
            GetButton("reset_link").onClick.AddListener(delegate () { PHUtils.ResetLink_method(); });
            isBodyPosing = true;
            GetButton("switch").onClick.AddListener(delegate ()
            {
                ToggleBodyPosing();
            });
            GetButton("alignment").onClick.AddListener(delegate ()
            {
                PHUtils.ChangeAlignment();

                alignmentText.text = alingmentStrings[PHUtils.motionTransformIndex];
            });
            InitStateButtons();

            phHandPosingMenu.SetActive(false);
            phHandPosingAdvanced.SetActive(PHHands.isAdvancedMode);
            phHandPosingMinimal.SetActive(!PHHands.isAdvancedMode);
            Refresh();
            UpdateSelectedAtom();
            PHMove.InitUI();
            PHMenuSetActive(false);
        }
        public static string GetCurrentKey()
        {
            return PHUtils.activeAtom.uidWithoutSubScenePath + ":" + (isBodyPosing ? "body" : "hand");
        }
        public static void ToggleBodyPosing()
        {
            symmetryDic[GetCurrentKey()] = isSymmetryToggled;

            if (isSymmetryToggled)
                PHUtils.ToggleSymmetry();

            isBodyPosing = !isBodyPosing;

            GameObject.Find("PH_switch").transform.GetChild(0).GetComponent<Image>().sprite = isBodyPosing ? stateTextures.Get("hand") : stateTextures.Get("body");
            phBodyPosingMenu.SetActive(isBodyPosing); phHandPosingMenu.SetActive(!isBodyPosing);

            if (symmetryDic.ContainsKey(GetCurrentKey()) && symmetryDic[GetCurrentKey()] != isSymmetryToggled)
                PHUtils.ToggleSymmetry();

            symmetryDic[PHUtils.activeAtom.uidWithoutSubScenePath + ":" + (isBodyPosing?"body":"hand")] = isSymmetryToggled;

            if (!isBodyPosing && PHHands.isAdvancedMode && !PHUtils.activeAtom.GetStorableIDs().Any((storable) => storable.Contains("PHFingerSliders")))
                PHHands.SwitchMode();

        }
        static void InitGizmo()
        {
            GameObject.Find("PH_pgizmo").AddComponent<Gizmo>();
            GameObject.Find("PH_rgizmo").AddComponent<Gizmo>();
        }
        static void InitStateButtons()
        {
            InitStateButton("on", FreeControllerV3.PositionState.On, FreeControllerV3.RotationState.On);
            InitStateButton("off", FreeControllerV3.PositionState.Off, FreeControllerV3.RotationState.Off);
            InitStateButton("parent_link", FreeControllerV3.PositionState.ParentLink, FreeControllerV3.RotationState.ParentLink);
            InitStateButton("physics_link", FreeControllerV3.PositionState.PhysicsLink, FreeControllerV3.RotationState.PhysicsLink);
            InitStateButton("hold", FreeControllerV3.PositionState.Hold, FreeControllerV3.RotationState.Hold);
            InitStateButton("lock", FreeControllerV3.PositionState.Lock, FreeControllerV3.RotationState.Lock);
            InitStateButton("comply", FreeControllerV3.PositionState.Comply, FreeControllerV3.RotationState.Comply);
        }
        static void InitStateButton(string name, FreeControllerV3.PositionState pState, FreeControllerV3.RotationState rState)
        {
            stateButtons.Add(GameObject.Find($"PH_state_{name}").AddComponent<StateButton>());
            stateButtons.Last().InitStates(pState, rState);
        }
        public static Button GetButton(string name)
        {
            var go = GameObject.Find($"PH_{name}");
            return go.GetComponent<Button>() == null ? go.AddComponent<Button>() : go.GetComponent<Button>();

        }
        public static string GetHandSideText()
        {
            return isRightSide ? "Right" : "Left";
        }
        static GameObject GetNodeElemement(string name)
        {
            return GameObject.Find($"PH_node_{name}");
        }
        public static void Refresh()
        {
            if (controllableAtoms == null)
                controllableAtoms = new List<string>();

            controllableAtoms.Clear();

            foreach (var atom in SuperController.singleton.GetAtoms())
            {
                if (atom.mainController != null && atom.type == "Person")
                {
                    controllableAtoms.Add(atom.uid);
                }
            }

            if (controllableAtoms.Count == 0)
            {
                activeAtomNameUI.text = "NULL";
                PHUtils.activeAtom = null;
            }
        }
        public static void ClearActiveNodes()
        {
            foreach (var node in PHUtils.activeNodes)
            {
                node.Clear();
            }
            PHUtils.activeNodes.Clear();
        }
        public static void SelectNextAtom()
        {
            Refresh();
            currentNameIndex = (currentNameIndex + 1) % controllableAtoms.Count;
            UpdateSelectedAtom();
        }
        static void SelectPreviousAtom()
        {
            Refresh();
            currentNameIndex = currentNameIndex == 0 ? controllableAtoms.Count - 1 : currentNameIndex - 1;
            UpdateSelectedAtom();
        }
        static void UpdateRetrievedConrollers()
        {
            if (PHUtils.activeAtom == null) return;
            List<string> nodesNames = PHUtils.activeNodes.Select(n => n.controller.name).ToList();
            RetrivedControllers[PHUtils.activeAtom.name] = nodesNames;
            RetrivedControllers["keep"] = nodesNames;
        }
        static void UpdateSelectedAtom()
        {
            if (PHUtils.activeAtom != null)
                symmetryDic[GetCurrentKey()] = isSymmetryToggled;
            PHUndo.Clear();
            PHHands.UpdateRetrivedSides();
            UpdateRetrievedConrollers();
            if (controllableAtoms.Count == 0)
                return;

            string atomName;


            atomName = controllableAtoms.ElementAt(currentNameIndex);
            if (atomName != null)
            {
                if (isSymmetryToggled)
                    PHUtils.ToggleSymmetry();
                SelectAtom(atomName);
                if (symmetryDic.ContainsKey(GetCurrentKey()) && symmetryDic[GetCurrentKey()] != isSymmetryToggled)
                    PHUtils.ToggleSymmetry();
            }
        }
        static private void SelectAtom(string atomName)
        {
            activeAtomNameUI.text = atomName;
            PHUtils.UpdateNodes(SuperController.singleton.GetAtomByUid(atomName));
        }
        public static void UpdateNode(string name, FreeControllerV3 fc)
        {
            GameObject nodeObj = GameObject.Find($"PH_node_{name}");
            Node node = new Node(fc, nodeObj.GetComponent<Image>(), null);
            nodeObj.GetComponent<NodeSelector>().SetNodes(node, null);
        }
        public static void UpdateNodeAlt(string name, FreeControllerV3 fc, string altName, FreeControllerV3 altFc)
        {
            GameObject nodeObj = GameObject.Find($"PH_node_{name}");
            Node node = new Node(fc, nodeObj.GetComponent<Image>(), null);

            GameObject altNodeObj = GameObject.Find($"PH_node_{altName}");
            Node altNode = new Node(altFc, altNodeObj.GetComponent<Image>(), node);
            node.altNode = altNode;

            nodeObj.GetComponent<NodeSelector>().SetNodes(node, altNode);
            altNodeObj.GetComponent<NodeSelector>().SetNodes(altNode, node);
        }
    }
    public class Node
    {
        public Node altNode;
        public FreeControllerV3 controller;
        public bool isDirty;
        Image buttonImage;
        public Node(FreeControllerV3 node, Image image, Node altNode)
        {
            this.controller = node;
            this.buttonImage = image;
            this.altNode = altNode;
            this.isDirty = false;
        }
        public void Clear()
        {
            buttonImage.color = Color.white;
        }
        public void Select()
        {
            buttonImage.color = Color.green;
            PHUtils.activeNodes.Add(this);
            PHUI.UpdateStates(this);
        }
        public void Select(bool append)
        {
            if (!append)
            {
                PHUI.ClearActiveNodes();
            }
            if (PHUtils.activeNodes.Contains(this))
            {
                if (PHInput.GetModifier(PHInput.MODIFIER_CTRL))
                {
                    PHUtils.activeNodes.Remove(this);
                    this.Clear();
                }
                return;
            }

            this.Select();

            if (PHInput.GetModifier(PHInput.MODIFIER_SHIFT) && PHUtils.activeNodes.Count > 1)
            {
                Node[] select = PHLinker.FindPath(PHUtils.activeNodes[PHUtils.activeNodes.Count - 2].controller, PHUtils.activeNodes.Last().controller);
                foreach (var node in select)
                {
                    if (!PHUtils.activeNodes.Contains(node))
                        node.Select();
                }
            }
        }
    }
    class ResetButton : MonoBehaviour, IPointerClickHandler
    {
        public void OnPointerClick(PointerEventData eventData)
        {
            if (PHUI.isBodyPosing)
            {
                if (eventData.button == PointerEventData.InputButton.Left)
                {
                    PHUtils.ResetPosePartial();
                    if (PH.changeFaicalPose.valNoCallback)
                        PHUtils.ResetMorphs();
                }
                else if (eventData.button == PointerEventData.InputButton.Right)
                {
                    PHUtils.ResetPoseFull();
                    PHUtils.ResetMorphs();
                }
                else if (eventData.button == PointerEventData.InputButton.Middle)
                {
                    PHUtils.ResetPosition();
                }
            }
            else
            {
                if (eventData.button == PointerEventData.InputButton.Left)
                {
                    if (PHHands.isAdvancedMode)
                        PHHands.ResetHandAdvanced();
                    else
                        PHHands.ResetHandMinimal();
                }
                else if (eventData.button == PointerEventData.InputButton.Right)
                {
                    PHHands.ResetHandAdvanced();
                    PHHands.ResetHandMinimal();
                }
            }
        }
    }
    class StateButton : MonoBehaviour, IPointerClickHandler
    {
        bool interactible = true;
        public FreeControllerV3.PositionState pState;
        public FreeControllerV3.RotationState rState;
        Image img;
        public void SetInteractible(bool interactible)
        {
            this.interactible = interactible;
            img.color = interactible ? Color.white : Color.gray;
        }
        public void SetTexture(bool pstate, bool rstate)
        {
            string texture = (pstate ? "on" : "off") + "_" + (rstate ? "on" : "off");
            img.sprite = PHUI.stateTextures.Get(texture);
        }
        public void InitStates(FreeControllerV3.PositionState pState, FreeControllerV3.RotationState rState)
        {
            this.pState = pState;
            this.rState = rState;
            img = GetComponent<Image>();
            img.type = Image.Type.Simple;
            img.sprite = PHUI.stateTextures.Get("off_off");
            img.preserveAspect = true;
        }
        public void OnPointerClick(PointerEventData eventData)
        {
            if (!interactible)
                return;
            if (eventData.button == PointerEventData.InputButton.Left)
            {
                SetPositionStates();
            }
            else if (eventData.button == PointerEventData.InputButton.Right)
            {
                SetRotationStates();
            }
            else if (eventData.button == PointerEventData.InputButton.Middle)
            {
                SetPositionStates();
                SetRotationStates();
            }
        }
        void SetPositionStates()
        {
            foreach (var node in PHUtils.activeNodes)
            {
                node.controller.currentPositionState = pState;
                if (PHUI.isSymmetryToggled && node.altNode != null)
                {
                    node.altNode.controller.currentPositionState = pState;
                }
            }
            PHUI.UpdateStates(PHUtils.activeNodes.Last());
        }
        void SetRotationStates()
        {
            foreach (var node in PHUtils.activeNodes)
            {
                node.controller.currentRotationState = rState;
                if (PHUI.isSymmetryToggled && node.altNode != null)
                {
                    node.altNode.controller.currentRotationState = rState;
                }
            }
            PHUI.UpdateStates(PHUtils.activeNodes.Last());
        }
    }
    class NodeSelector : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler
    {
        public Node node;
        bool isMoused = false, isInteractible = false;
        public void SetNodes(Node node, Node alt)
        {
            isInteractible = true;
            this.node = node;
            this.node.altNode = alt;
        }
        public void SetInteractable(bool interactable)
        {
            isInteractible = interactable;
            GetComponent<Image>().color = isInteractible ? Color.white : Color.gray;
        }
        public void OnPointerEnter(PointerEventData eventData)
        {
            isMoused = true;
        }
        public void OnPointerExit(PointerEventData eventData)
        {
            isMoused = false;
        }
        void Update()
        {
            if (!isMoused)
                return;
            if (isInteractible && Input.GetMouseButtonDown(PHUI.MOUSE_LEFT))
            {
                node.Select((PHInput.GetModifier(PHInput.MODIFIER_CTRL) || PHInput.GetModifier(PHInput.MODIFIER_SHIFT)));
            }
            if (Input.GetMouseButtonDown(PHUI.MOUSE_RIGHT))
            {
                if (PHInput.GetModifier(PHInput.MODIFIER_SHIFT))
                    SuperController.singleton.FocusOnController(node.controller, true, true);
                else if (PHInput.GetModifier(PHInput.MODIFIER_CTRL))
                    node.controller.SelectAlignToRigidbodyFromScene();
                else
                    SuperController.singleton.SelectController(node.controller, false, false, false, true);
            }
            else if (Input.GetMouseButtonDown(PHUI.MOUSE_MIDDLE))
            {
                if (node.altNode == null)
                    return;
                if (PHInput.GetModifier(PHInput.MODIFIER_SHIFT))
                    PHUtils.SwapNode(node);
                else if (PHInput.GetModifier(PHInput.MODIFIER_ALT))
                    PHUtils.MirrorNode(node.altNode);
                else
                    PHUtils.MirrorNode(node);
            }
        }
    }
    class Gizmo : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler
    {
        bool isHeld = false;
        bool isMoused = false;
        float left, bottom, right, top;
        int axisCount;
        bool forRotation = false;
        static Vector2[] XYPolygon = new Vector2[4] { new Vector2(0.6913652f, 0.09276665f), new Vector2(0.9928437f, 0.2536683f), new Vector2(0.9945374f, 0.5483725f), new Vector2(0.6812027f, 0.397633f) };
        static Vector2[] YZPolygon = new Vector2[4] { new Vector2(0.3052013f, 0.09784769f), new Vector2(0.005416478f, 0.2536683f), new Vector2(0.008803835f, 0.5483725f), new Vector2(0.330607f, 0.3925519f) };
        static Vector2[] ZXPolygon = new Vector2[4] { new Vector2(0.5050582f, 0.682175f), new Vector2(0.7879058f, 0.841383f), new Vector2(0.5050573f, 0.9972036f), new Vector2(0.2205151f, 0.8447704f) };
        static Vector2[] YPolygon = new Vector2[6] { new Vector2(0.500124f, 0.002481121f), new Vector2(0.6496612f, 0.07802071f), new Vector2(0.6481199f, 0.3817206f), new Vector2(0.5032069f, 0.4757596f), new Vector2(0.3582944f, 0.3986785f), new Vector2(0.3613778f, 0.07031259f) };
        static Vector2[] ZPolygon = new Vector2[6] { new Vector2(0.4692915f, 0.5250916f), new Vector2(0.3274619f, 0.4480104f), new Vector2(0.01605372f, 0.6098809f), new Vector2(0.02067887f, 0.7347525f), new Vector2(0.1640497f, 0.8118336f), new Vector2(0.4739162f, 0.6407134f) };
        static Vector2[] XPolygon = new Vector2[6] { new Vector2(0.5355811f, 0.6515048f), new Vector2(0.5355811f, 0.511217f), new Vector2(0.6743273f, 0.4480104f), new Vector2(0.9857355f, 0.6037144f), new Vector2(0.9872772f, 0.7332108f), new Vector2(0.8423642f, 0.8133752f) };
        string dir;
        Vector3[] uiCorners = new Vector3[4];
        RectTransform gizmoRect;
        public struct PolygonGroup
        {
            public string dir;
            public Vector2[] polygons;
            public PolygonGroup(string dir, Vector2[] polygons)
            {
                this.dir = dir;
                this.polygons = polygons;
            }
        }
        PolygonGroup[] groups = new PolygonGroup[6] { new PolygonGroup(" X", YPolygon), new PolygonGroup("X", XPolygon), new PolygonGroup("  X", ZPolygon), new PolygonGroup("XY", XYPolygon), new PolygonGroup(" XY", YZPolygon), new PolygonGroup("Y X", ZXPolygon) };
        void Start()
        {
            gizmoRect = GetComponent<RectTransform>();
            if (gameObject.name.Split('_')[1][0] == 'r')
            {
                axisCount = 3;
                forRotation = true;
            }
            else
            {
                axisCount = 6;
                forRotation = false;
            }
        }
        public void OnPointerEnter(PointerEventData eventData)
        {
            isMoused = true;
        }
        public void OnPointerExit(PointerEventData eventData)
        {
            isMoused = false;
        }

        bool PointisInPolygon(float x, float y, Vector2[] polygon)
        {
            float minX = polygon[0].x;
            float maxX = polygon[0].x;
            float minY = polygon[0].y;
            float maxY = polygon[0].y;
            for (int i = 1; i < polygon.Length; i++)
            {
                Vector2 q = polygon[i];
                minX = Mathf.Min(q.x, minX);
                maxX = Mathf.Max(q.x, maxX);
                minY = Mathf.Min(q.y, minY);
                maxY = Mathf.Max(q.y, maxY);
            }

            if (x < minX || x > maxX || y < minY || y > maxY)
            {
                return false;
            }

            bool inside = false;
            for (int i = 0, j = polygon.Length - 1; i < polygon.Length; j = i++)
            {
                if ((polygon[i].y > y) != (polygon[j].y > y) &&
                     x < (polygon[j].x - polygon[i].x) * (y - polygon[i].y) / (polygon[j].y - polygon[i].y) + polygon[i].x)
                {
                    inside = !inside;
                }
            }
            return inside;
        }
        void Update()
        {
            if (!PHUI.isBodyPosing)
                return;
            if (!isHeld && isMoused && Input.GetMouseButtonDown(PHUI.MOUSE_LEFT))
            {
                gizmoRect.GetWorldCorners(uiCorners);
                left = uiCorners[0].x; bottom = uiCorners[0].y; right = uiCorners[2].x; top = uiCorners[2].y;
                float x = Input.mousePosition.x;
                float y = Input.mousePosition.y;
                x = (right - x) / (right - left);
                y = (top - y) / (top - bottom);
                for (int i = 0; i < axisCount; i++)
                    if (PointisInPolygon(x, y, groups[i].polygons))
                    {
                        PHUtils.PreMoveControllers();
                        dir = groups[i].dir;
                    }
                isHeld = true;
            }
            if (isHeld)
            {
                float MX = Input.GetAxis("Mouse X");
                float MY = -Input.GetAxis("Mouse Y");
                Vector3 moveDir = Vector3.zero;
                switch (dir)
                {
                    case "XY":
                        moveDir = new Vector3(MX, MY, 0);
                        break;
                    case " XY":
                        moveDir = new Vector3(0, -MY, MX);
                        break;
                    case "Y X":
                        moveDir = new Vector3(MX, 0, MY);
                        break;
                    case "X":
                        moveDir = new Vector3(MX, 0, 0);
                        break;
                    case " X":
                        moveDir = new Vector3(0, MX, 0);
                        break;
                    case "  X":
                        moveDir = new Vector3(0, 0, MX);
                        break;

                }
                if (forRotation)
                    PHUtils.RotateActiveNodes(moveDir);
                else
                    PHUtils.MoveActiveNodes(moveDir);
            }
            if (isHeld && Input.GetMouseButtonUp(PHUI.MOUSE_LEFT))
            {
                PHUtils.PostMoveControllers();
                isHeld = false;
            }
        }
    }

    class HandGizmo : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler
    {
        bool isHeld = false;
        bool isMoused = false;
        float left, bottom, right, top;
        int axisCount;
        static Vector2[] YPolygon = new Vector2[6] { new Vector2(0.500124f, 0.002481121f), new Vector2(0.6496612f, 0.07802071f), new Vector2(0.6481199f, 0.3817206f), new Vector2(0.5032069f, 0.4757596f), new Vector2(0.3582944f, 0.3986785f), new Vector2(0.3613778f, 0.07031259f) };
        static Vector2[] ZPolygon = new Vector2[6] { new Vector2(0.4692915f, 0.5250916f), new Vector2(0.3274619f, 0.4480104f), new Vector2(0.01605372f, 0.6098809f), new Vector2(0.02067887f, 0.7347525f), new Vector2(0.1640497f, 0.8118336f), new Vector2(0.4739162f, 0.6407134f) };
        static Vector2[] XPolygon = new Vector2[6] { new Vector2(0.5355811f, 0.6515048f), new Vector2(0.5355811f, 0.511217f), new Vector2(0.6743273f, 0.4480104f), new Vector2(0.9857355f, 0.6037144f), new Vector2(0.9872772f, 0.7332108f), new Vector2(0.8423642f, 0.8133752f) };
        string dir;
        Vector3[] uiCorners = new Vector3[4];
        RectTransform gizmoRect;
        public struct PolygonGroup
        {
            public string dir;
            public Vector2[] polygons;
            public PolygonGroup(string dir, Vector2[] polygons)
            {
                this.dir = dir;
                this.polygons = polygons;
            }
        }
        PolygonGroup[] groups = new PolygonGroup[3] { new PolygonGroup(" X", YPolygon), new PolygonGroup("X", XPolygon), new PolygonGroup("  X", ZPolygon) };
        void Start()
        {
            gizmoRect = GetComponent<RectTransform>();
            axisCount = 3;
        }
        public void OnPointerEnter(PointerEventData eventData)
        {
            isMoused = true;
        }
        public void OnPointerExit(PointerEventData eventData)
        {
            isMoused = false;
        }

        bool PointisInPolygon(float x, float y, Vector2[] polygon)
        {
            float minX = polygon[0].x;
            float maxX = polygon[0].x;
            float minY = polygon[0].y;
            float maxY = polygon[0].y;
            for (int i = 1; i < polygon.Length; i++)
            {
                Vector2 q = polygon[i];
                minX = Mathf.Min(q.x, minX);
                maxX = Mathf.Max(q.x, maxX);
                minY = Mathf.Min(q.y, minY);
                maxY = Mathf.Max(q.y, maxY);
            }

            if (x < minX || x > maxX || y < minY || y > maxY)
            {
                return false;
            }

            bool inside = false;
            for (int i = 0, j = polygon.Length - 1; i < polygon.Length; j = i++)
            {
                if ((polygon[i].y > y) != (polygon[j].y > y) &&
                     x < (polygon[j].x - polygon[i].x) * (y - polygon[i].y) / (polygon[j].y - polygon[i].y) + polygon[i].x)
                {
                    inside = !inside;
                }
            }
            return inside;
        }
        void Update()
        {
            if (!isHeld && isMoused && Input.GetMouseButtonDown(PHUI.MOUSE_LEFT))
            {
                gizmoRect.GetWorldCorners(uiCorners);
                left = uiCorners[0].x; bottom = uiCorners[0].y; right = uiCorners[2].x; top = uiCorners[2].y;
                float x = Input.mousePosition.x;
                float y = Input.mousePosition.y;
                x = (right - x) / (right - left);
                y = (top - y) / (top - bottom);
                for (int i = 0; i < axisCount; i++)
                    if (PointisInPolygon(x, y, groups[i].polygons))
                    {
                        dir = groups[i].dir;
                    }
                isHeld = true;
            }
            if (isHeld)
            {
                float MX = Input.GetAxis("Mouse X");
                Vector3 rotateDir = Vector3.zero;
                switch (dir)
                {
                    case "X":
                        rotateDir = new Vector3(MX, 0, 0);
                        break;
                    case " X":
                        rotateDir = new Vector3(0, MX, 0);
                        break;
                    case "  X":
                        rotateDir = new Vector3(0, 0, MX);
                        break;
                }
                PHHands.RotateActiveHandBones(rotateDir);
            }
            if (isHeld && Input.GetMouseButtonUp(PHUI.MOUSE_LEFT))
            {
                isHeld = false;
            }
        }
    }
}